class DIAG_FILLER inherit OBSERVER
creation make
feature
	make(row_number : INTEGER; column_number : INTEGER) is
	do
		row := row_number
		col := column_number
	end

	update(command : ADD_QUEEN) is
	local
		bb : QUEENBOARD
		x : INTEGER
		y : INTEGER
		count : INTEGER
	do
		bb := command.bb
		from
			count := 0
			if (row < col) then
				x := 1
				y := col - row + 1
			else
				x := row - col + 1
				y := 1
			end
		until x > bb.size or y > bb.size
		loop
			inspect bb.board.item(x, y)
			when 0 then
				command.forced_mark(x, y)
			when 1 then
				count := count + 1
			else
			end
			x := x + 1
			y := y + 1
		end

		if count > 1 then
			command.forced_die
		end

		from
			count := 0

			if (row < bb.size - col + 1) then
				x := 1
				y := col + row - 1
			else
				x := row - bb.size + col
				y := bb.size
			end
		until x > bb.size or y < 1
		loop
			inspect bb.board.item(x, y)
			when 0 then
				command.forced_mark(x, y)
			when 1 then
				count := count + 1
			else
			end
			x := x + 1
			y := y - 1
		end

		if count > 1 then
			command.forced_die
		end
	end

feature {NONE}
	row : INTEGER
	col : INTEGER
end
