-- Ben Lin 28/5/98
class CROSS_LINK inherit OBSERVER
	-- Makes sure destination is crossed if called. See tick_link
creation make
feature
	make(i_dest, j_dest, x_dest, y_dest : INTEGER) is
	do
		i := i_dest
		j := j_dest
		x := x_dest
		y := y_dest
	end

	update(last : LP_COMMAND) is
	local
		bb : LP_BOARD
		count : INTEGER
	do
		bb := last.bb
		inspect bb.board.item(i, j, x, y)
		when 1 then
			last.forced_die
		when 0 then
			last.forced_cross(i, j, x, y)
		else
		end
	end

feature {NONE}
	i, j, x, y : INTEGER
end

