-- observer.e
--
-- Ben Lin 5/98
--
-- (Observer Pattern)
--
-- A particular observer is notified by certain commands. Once notified,
-- a typical observer will add forced moves (if any) to the command's
-- forced_move list. (This includes the die command.) The command handles
-- the rest.
--
-- 9/6/98 - Added comments.

deferred class OBSERVER
	-- Observer - notified by certain commands.
feature
	update(command : COMMAND) is
		-- Call this to notify the observer
	deferred end
end
